﻿Imports AForge.Video.DirectShow

Public Class Form1
    Private VideoSource As VideoCaptureDevice

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim VideoSources = New FilterInfoCollection(FilterCategory.VideoInputDevice)
        If VideoSources IsNot Nothing AndAlso VideoSources.Count > 0 Then
            VideoSource = New VideoCaptureDevice(VideoSources(0).MonikerString)
            AddHandler VideoSource.NewFrame, AddressOf VideoSource_NewFrame
        End If
    End Sub

    Private Sub VideoSource_NewFrame(sender As Object, eventArgs As AForge.Video.NewFrameEventArgs)
        If PbWebcam.Image IsNot Nothing Then
            PbWebcam.Image.Dispose()
        End If
        PbWebcam.Image = DirectCast(eventArgs.Frame.Clone(), Bitmap)
    End Sub

    Private Sub BtLigarDesligar_Click(sender As Object, e As EventArgs) Handles BtLigarDesligar.Click
        If VideoSource.IsRunning Then
            VideoSource.Stop()
            PbWebcam.Image = Nothing
        Else
            VideoSource.Start()
        End If
    End Sub

    Private Sub BtCapturar_Click(sender As Object, e As EventArgs) Handles BtCapturar.Click
        If PbWebcam.Image IsNot Nothing Then
            Try
                RemoveHandler VideoSource.NewFrame, AddressOf VideoSource_NewFrame

                Using dialog = New SaveFileDialog()
                    dialog.DefaultExt = "png"
                    dialog.AddExtension = True

                    If dialog.ShowDialog() = DialogResult.OK Then
                        PbWebcam.Image.Save(dialog.FileName, System.Drawing.Imaging.ImageFormat.Png)
                    End If
                End Using
            Finally
                AddHandler VideoSource.NewFrame, AddressOf VideoSource_NewFrame
            End Try
        End If
    End Sub

    Protected Overrides Sub OnFormClosing(e As FormClosingEventArgs)
        If VideoSource.IsRunning Then
            VideoSource.[Stop]()
        End If
        MyBase.OnFormClosing(e)
    End Sub
End Class
